package cn.wisenergy.service.app;

import cn.wisenergy.common.utils.R;
import cn.wisenergy.model.dto.UserInfoDto;
import cn.wisenergy.model.vo.AccountLoginVo;
import cn.wisenergy.model.vo.UserVipCommitVo;
import cn.wisenergy.model.vo.UserVipQueryVo;
import com.github.pagehelper.PageInfo;

public interface StaffUserVipService {

    /**
     * 员工登录
     *
     * @return true：成功 false：失败
     */
    R<Boolean> staffLogin(AccountLoginVo accountLoginVo);

    /**
     * 获取员工学生关系表
     *
     * @param userVipQueryVo 查询信息
     * @return
     */
    R<PageInfo<UserInfoDto>> getList(UserVipQueryVo userVipQueryVo);

    /**
     * 添加员工和vip客户关系
     * @param userVipCommitVo 添加信息
     * @return true：成功 false：失败
     */
    R<Boolean> addUserVip(UserVipCommitVo userVipCommitVo);

    /**
     *  添加员工和vip客户关系
     * @param staffId 员工id
     * @param phone 手机号
     * @return true：成功 false：失败
     */
    R<Boolean> addUserByPhone(Integer staffId,String phone);


}